diff --git a/src/bin/pg_combinebackup/reconstruct.c b/src/bin/pg_combinebackup/reconstruct.c
new file mode 100644
index 0000000000..c774bf1842
--- /dev/null
+++ b/src/bin/pg_combinebackup/reconstruct.c
@@ -0,0 +1,618 @@
+/*-------------------------------------------------------------------------
+ *
+ * reconstruct.c
+ *		Reconstruct full file from incremental file and backup chain.
+ *
+ * Copyright (c) 2017-2023, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/bin/pg_combinebackup/reconstruct.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres_fe.h"
+
+#include <unistd.h>
+
+#include "backup/basebackup_incremental.h"
+#include "common/logging.h"
+#include "common/file_perm.h"
+#include "copy_file.h"
+#include "reconstruct.h"
+#include "storage/block.h"
+
+/*
+ * An rfile stores the data that we need in order to be able to use some file
+ * on disk for reconstruction. For any given output file, we create one rfile
+ * per backup that we need to consult when we constructing that output file.
+ *
+ * If we find a full version of the file in the backup chain, then only
+ * filename and fd are initialized; the remaining fields are 0 or NULL.
+ * For an incremental file, header_length, num_blocks, relative_block_numbers,
+ * and truncation_block_length are also set.
+ *
+ * num_blocks_read and highest_offset_read always start out as 0.
+ */
+typedef struct rfile
+{
+	char	   *filename;
+	int			fd;
+	size_t		header_length;
+	unsigned	num_blocks;
+	BlockNumber *relative_block_numbers;
+	unsigned	truncation_block_length;
+	unsigned	num_blocks_read;
+	off_t		highest_offset_read;
+} rfile;
+
+static void debug_reconstruction(int n_source,
+								 rfile **sources,
+								 bool dry_run);
+static unsigned find_reconstructed_block_length(rfile *s);
+static rfile *make_incremental_rfile(char *filename);
+static rfile *make_rfile(char *filename, bool missing_ok);
+static void write_reconstructed_file(char *input_filename,
+									 char *output_filename,
+									 unsigned block_length,
+									 rfile **sourcemap,
+									 off_t *offsetmap,
+									 pg_checksum_context *checksum_ctx,
+									 bool dry_run);
+static void read_bytes(rfile *rf, void *buffer, unsigned length);
+
+/*
+ * Reconstruct a full file from an incremental file and a chain of prior
+ * backups.
+ *
+ * input_filename should be the path to the incremental file, and
+ * output_filename should be the path where the reconstructed file is to be
+ * written.
+ *
+ * relative_path should be the relative path to the directory containing this
+ * file. bare_file_name should be the name of the file within that directory,
+ * without "INCREMENTAL.".
+ *
+ * n_prior_backups is the number of prior backups, and prior_backup_dirs is
+ * an array of pathnames where those backups can be found.
+ */
+void
+reconstruct_from_incremental_file(char *input_filename,
+								  char *output_filename,
+								  char *relative_path,
+								  char *bare_file_name,
+								  int n_prior_backups,
+								  char **prior_backup_dirs,
+								  manifest_data **manifests,
+								  char *manifest_path,
+								  pg_checksum_type checksum_type,
+								  int *checksum_length,
+								  uint8 **checksum_payload,
+								  bool dry_run)
+{
+	rfile	  **source;
+	rfile	   *latest_source = NULL;
+	rfile	  **sourcemap;
+	off_t	   *offsetmap;
+	unsigned	block_length;
+	unsigned	num_missing_blocks;
+	unsigned	i;
+	unsigned	sidx = n_prior_backups;
+	bool		full_copy_possible = true;
+	int			copy_source_index = -1;
+	rfile	   *copy_source = NULL;
+	pg_checksum_context checksum_ctx;
+
+	/*
+	 * Every block must come either from the latest version of the file or
+	 * from one of the prior backups.
+	 */
+	source = pg_malloc0(sizeof(rfile *) * (1 + n_prior_backups));
+
+	/*
+	 * Use the information from the latest incremental file to figure out how
+	 * long the reconstructed file should be.
+	 */
+	latest_source = make_incremental_rfile(input_filename);
+	source[n_prior_backups] = latest_source;
+	block_length = find_reconstructed_block_length(latest_source);
+
+	/*
+	 * For each block in the output file, we need to know from which file we
+	 * need to obtain it and at what offset in that file it's stored.
+	 * sourcemap gives us the first of these things, and offsetmap the latter.
+	 */
+	sourcemap = pg_malloc0(sizeof(rfile *) * block_length);
+	offsetmap = pg_malloc0(sizeof(off_t) * block_length);
+
+	/*
+	 * Blocks prior to the truncation_block_length threshold must be obtained
+	 * from some prior backup, while those after that threshold are left as
+	 * zeroes if not present in the newest incremental file.
+	 * num_missing_blocks counts the number of blocks that we must be found
+	 * somewhere in the backup chain, and is thus initially equal to
+	 * truncation_block_length.
+	 */
+	num_missing_blocks = latest_source->truncation_block_length;
+
+	/*
+	 * Every block that is present in the newest incremental file should be
+	 * sourced from that file. If it precedes the truncation_block_length,
+	 * it's a block that we would otherwise have had to find in an older
+	 * backup and thus reduces the number of blocks remaining to be found by
+	 * one; otherwise, it's an extra block that needs to be included in the
+	 * output but would not have needed to be found in an older backup if it
+	 * had not been present.
+	 */
+	for (i = 0; i < latest_source->num_blocks; ++i)
+	{
+		BlockNumber b = latest_source->relative_block_numbers[i];
+
+		Assert(b < block_length);
+		sourcemap[b] = latest_source;
+		offsetmap[b] = latest_source->header_length + (i * BLCKSZ);
+		if (b < latest_source->truncation_block_length)
+			num_missing_blocks--;
+
+		/*
+		 * A full copy of a file from an earlier backup is only possible if no
+		 * blocks are needed from any later incremental file.
+		 */
+		full_copy_possible = false;
+	}
+
+	while (num_missing_blocks > 0)
+	{
+		char		source_filename[MAXPGPATH];
+		rfile	   *s;
+
+		/*
+		 * Move to the next backup in the chain. If there are no more, then
+		 * something has gone wrong and reconstruction has failed.
+		 */
+		if (sidx == 0)
+			pg_fatal("reconstruction for file \"%s\" failed to find %u required blocks",
+					 output_filename, num_missing_blocks);
+		--sidx;
+
+		/*
+		 * Look for the full file in the previous backup. If not found, then
+		 * look for an incremental file instead.
+		 */
+		snprintf(source_filename, MAXPGPATH, "%s/%s/%s",
+				 prior_backup_dirs[sidx], relative_path, bare_file_name);
+		if ((s = make_rfile(source_filename, true)) == NULL)
+		{
+			snprintf(source_filename, MAXPGPATH, "%s/%s/INCREMENTAL.%s",
+					 prior_backup_dirs[sidx], relative_path, bare_file_name);
+			s = make_incremental_rfile(source_filename);
+		}
+		source[sidx] = s;
+
+		/*
+		 * If s->header_length == 0, then this is a full file; otherwise, it's
+		 * an incremental file.
+		 */
+		if (s->header_length != 0)
+		{
+			/*
+			 * Since we found another incremental file, source all blocks from
+			 * it that we need but don't yet have.
+			 */
+			for (i = 0; i < s->num_blocks; ++i)
+			{
+				BlockNumber b = s->relative_block_numbers[i];
+
+				if (b < latest_source->truncation_block_length &&
+					sourcemap[b] == NULL)
+				{
+					sourcemap[b] = s;
+					offsetmap[b] = s->header_length + (i * BLCKSZ);
+
+					Assert(num_missing_blocks > 0);
+					--num_missing_blocks;
+
+					/*
+					 * A full copy of a file from an earlier backup is only
+					 * possible if no blocks are needed from any later
+					 * incremental file.
+					 */
+					full_copy_possible = false;
+				}
+			}
+		}
+		else
+		{
+			BlockNumber b;
+
+			/*
+			 * Since we found a full file, source all remaining required
+			 * blocks from it.
+			 */
+			for (b = 0; b < latest_source->truncation_block_length; ++b)
+			{
+				if (sourcemap[b] == NULL)
+				{
+					sourcemap[b] = s;
+					offsetmap[b] = b * BLCKSZ;
+
+					Assert(num_missing_blocks > 0);
+					--num_missing_blocks;
+				}
+			}
+			Assert(num_missing_blocks == 0);
+
+			/*
+			 * If a full copy looks possible, check whether the resulting file
+			 * should be exactly as long as the source file is. If so, a full
+			 * copy is acceptable, otherwise not.
+			 */
+			if (full_copy_possible)
+			{
+				struct stat sb;
+				uint64		expected_length;
+
+				if (fstat(s->fd, &sb) < 0)
+					pg_fatal("could not stat \"%s\": %m", s->filename);
+				expected_length =
+					(uint64) latest_source->truncation_block_length;
+				expected_length *= BLCKSZ;
+				if (expected_length == sb.st_size)
+				{
+					copy_source = s;
+					copy_source_index = sidx;
+				}
+			}
+		}
+	}
+
+	/*
+	 * If a checksum of the required type already exists in the
+	 * backup_manifest for the relevant input directory, we can save some work
+	 * by reusing that checksum instead of computing a new one.
+	 */
+	if (copy_source_index >= 0 && manifests[copy_source_index] != NULL &&
+		checksum_type != CHECKSUM_TYPE_NONE)
+	{
+		manifest_file *mfile;
+
+		mfile = manifest_files_lookup(manifests[copy_source_index]->files,
+									  manifest_path);
+		if (mfile == NULL)
+		{
+			/*
+			 * The directory is out of sync with the backup_manifest, so emit
+			 * a warning.
+			 */
+			pg_log_warning("\"%s/backup_manifest\" contains no entry for \"%s\"",
+						   prior_backup_dirs[copy_source_index],
+						   manifest_path);
+		}
+		else if (mfile->checksum_type == checksum_type)
+		{
+			*checksum_length = mfile->checksum_length;
+			*checksum_payload = pg_malloc(*checksum_length);
+			memcpy(*checksum_payload, mfile->checksum_payload,
+				   *checksum_length);
+			checksum_type = CHECKSUM_TYPE_NONE;
+		}
+	}
+
+	/* Prepare for checksum calculation, if required. */
+	pg_checksum_init(&checksum_ctx, checksum_type);
+
+	/*
+	 * If the full file can be created by copying a file from an older backup
+	 * in the chain without needing to overwrite any blocks or truncate the
+	 * result, then forget about performing reconstruction and just copy that
+	 * file in its entirety.
+	 *
+	 * Otherwise, reconstruct.
+	 */
+	if (copy_source != NULL)
+		copy_file(copy_source->filename, output_filename,
+				  &checksum_ctx, dry_run);
+	else
+	{
+		write_reconstructed_file(input_filename, output_filename,
+								 block_length, sourcemap, offsetmap,
+								 &checksum_ctx, dry_run);
+		debug_reconstruction(n_prior_backups + 1, source, dry_run);
+	}
+
+	/* Save results of checksum calculation. */
+	if (checksum_type != CHECKSUM_TYPE_NONE)
+	{
+		*checksum_payload = pg_malloc(PG_CHECKSUM_MAX_LENGTH);
+		*checksum_length = pg_checksum_final(&checksum_ctx,
+											 *checksum_payload);
+	}
+
+	/*
+	 * Close files and release memory.
+	 */
+	for (i = 0; i <= n_prior_backups; ++i)
+	{
+		rfile	   *s = source[i];
+
+		if (s == NULL)
+			continue;
+		if (close(s->fd) != 0)
+			pg_fatal("could not close \"%s\": %m", s->filename);
+		if (s->relative_block_numbers != NULL)
+			pfree(s->relative_block_numbers);
+		pg_free(s->filename);
+	}
+	pfree(sourcemap);
+	pfree(offsetmap);
+	pfree(source);
+}
+
+/*
+ * Perform post-reconstruction logging and sanity checks.
+ */
+static void
+debug_reconstruction(int n_source, rfile **sources, bool dry_run)
+{
+	unsigned	i;
+
+	for (i = 0; i < n_source; ++i)
+	{
+		rfile	   *s = sources[i];
+
+		/* Ignore source if not used. */
+		if (s == NULL)
+			continue;
+
+		/* If no data is needed from this file, we can ignore it. */
+		if (s->num_blocks_read == 0)
+			continue;
+
+		/* Debug logging. */
+		if (dry_run)
+			pg_log_debug("would have read %u blocks from \"%s\"",
+						 s->num_blocks_read, s->filename);
+		else
+			pg_log_debug("read %u blocks from \"%s\"",
+						 s->num_blocks_read, s->filename);
+
+		/*
+		 * In dry-run mode, we don't actually try to read data from the file,
+		 * but we do try to verify that the file is long enough that we could
+		 * have read the data if we'd tried.
+		 *
+		 * If this fails, then it means that a non-dry-run attempt would fail,
+		 * complaining of not being able to read the required bytes from the
+		 * file.
+		 */
+		if (dry_run)
+		{
+			struct stat sb;
+
+			if (fstat(s->fd, &sb) < 0)
+				pg_fatal("could not stat \"%s\": %m", s->filename);
+			if (sb.st_size < s->highest_offset_read)
+				pg_fatal("file \"%s\" is too short: expected %llu, found %llu",
+						 s->filename,
+						 (unsigned long long) s->highest_offset_read,
+						 (unsigned long long) sb.st_size);
+		}
+	}
+}
+
+/*
+ * When we perform reconstruction using an incremental file, the output file
+ * should be at least as long as the truncation_block_length. Any blocks
+ * present in the incremental file increase the output length as far as is
+ * necessary to include those blocks.
+ */
+static unsigned
+find_reconstructed_block_length(rfile *s)
+{
+	unsigned	block_length = s->truncation_block_length;
+	unsigned	i;
+
+	for (i = 0; i < s->num_blocks; ++i)
+		if (s->relative_block_numbers[i] >= block_length)
+			block_length = s->relative_block_numbers[i] + 1;
+
+	return block_length;
+}
+
+/*
+ * Initialize an incremental rfile, reading the header so that we know which
+ * blocks it contains.
+ */
+static rfile *
+make_incremental_rfile(char *filename)
+{
+	rfile	   *rf;
+	unsigned	magic;
+
+	rf = make_rfile(filename, false);
+
+	/* Read and validate magic number. */
+	read_bytes(rf, &magic, sizeof(magic));
+	if (magic != INCREMENTAL_MAGIC)
+		pg_fatal("file \"%s\" has bad incremental magic number (0x%x not 0x%x)",
+				 filename, magic, INCREMENTAL_MAGIC);
+
+	/* Read block count. */
+	read_bytes(rf, &rf->num_blocks, sizeof(rf->num_blocks));
+	if (rf->num_blocks > RELSEG_SIZE)
+		pg_fatal("file \"%s\" has block count %u in excess of segment size %u",
+				 filename, rf->num_blocks, RELSEG_SIZE);
+
+	/* Read truncation block length. */
+	read_bytes(rf, &rf->truncation_block_length,
+			   sizeof(rf->truncation_block_length));
+	if (rf->truncation_block_length > RELSEG_SIZE)
+		pg_fatal("file \"%s\" has truncation block length %u in excess of segment size %u",
+				 filename, rf->truncation_block_length, RELSEG_SIZE);
+
+	/* Read block numbers if there are any. */
+	if (rf->num_blocks > 0)
+	{
+		rf->relative_block_numbers =
+			pg_malloc0(sizeof(BlockNumber) * rf->num_blocks);
+		read_bytes(rf, rf->relative_block_numbers,
+				   sizeof(BlockNumber) * rf->num_blocks);
+	}
+
+	/* Remember length of header. */
+	rf->header_length = sizeof(magic) + sizeof(rf->num_blocks) +
+		sizeof(rf->truncation_block_length) +
+		sizeof(BlockNumber) * rf->num_blocks;
+
+	return rf;
+}
+
+/*
+ * Allocate and perform basic initialization of an rfile.
+ */
+static rfile *
+make_rfile(char *filename, bool missing_ok)
+{
+	rfile	   *rf;
+
+	rf = pg_malloc0(sizeof(rfile));
+	rf->filename = pstrdup(filename);
+	if ((rf->fd = open(filename, O_RDONLY | PG_BINARY, 0)) < 0)
+	{
+		if (missing_ok && errno == ENOENT)
+		{
+			pg_free(rf);
+			return NULL;
+		}
+		pg_fatal("could not open file \"%s\": %m", filename);
+	}
+
+	return rf;
+}
+
+/*
+ * Read the indicated number of bytes from an rfile into the buffer.
+ */
+static void
+read_bytes(rfile *rf, void *buffer, unsigned length)
+{
+	unsigned	rb = read(rf->fd, buffer, length);
+
+	if (rb != length)
+	{
+		if (rb < 0)
+			pg_fatal("could not read file \"%s\": %m", rf->filename);
+		else
+			pg_fatal("could not read file \"%s\": read only %d of %d bytes",
+					 rf->filename, (int) rb, length);
+	}
+}
+
+/*
+ * Write out a reconstructed file.
+ */
+static void
+write_reconstructed_file(char *input_filename,
+						 char *output_filename,
+						 unsigned block_length,
+						 rfile **sourcemap,
+						 off_t *offsetmap,
+						 pg_checksum_context *checksum_ctx,
+						 bool dry_run)
+{
+	int			wfd = -1;
+	unsigned	i;
+	unsigned	zero_blocks = 0;
+
+	/* Debugging output. */
+	if (dry_run)
+		pg_log_debug("would reconstruct \"%s\" (%u blocks, checksum %s)",
+					 output_filename, block_length,
+					 pg_checksum_type_name(checksum_ctx->type));
+	else
+		pg_log_debug("reconstructing \"%s\" (%u blocks, checksum %s)",
+					 output_filename, block_length,
+					 pg_checksum_type_name(checksum_ctx->type));
+
+	/* Open the output file, except in dry_run mode. */
+	if (!dry_run &&
+		(wfd = open(output_filename,
+					O_RDWR | PG_BINARY | O_CREAT | O_EXCL,
+					pg_file_create_mode)) < 0)
+		pg_fatal("could not open file \"%s\": %m", output_filename);
+
+	/* Read and write the blocks as required. */
+	for (i = 0; i < block_length; ++i)
+	{
+		uint8		buffer[BLCKSZ];
+		rfile	   *s = sourcemap[i];
+		unsigned	wb;
+
+		/* Update accounting information. */
+		if (s == NULL)
+			++zero_blocks;
+		else
+		{
+			s->num_blocks_read++;
+			s->highest_offset_read = Max(s->highest_offset_read,
+										 offsetmap[i] + BLCKSZ);
+		}
+
+		/* Skip the rest of this in dry-run mode. */
+		if (dry_run)
+			continue;
+
+		/* Read or zero-fill the block as appropriate. */
+		if (s == NULL)
+		{
+			/*
+			 * New block not mentioned in the WAL summary. Should have been an
+			 * uninitialized block, so just zero-fill it.
+			 */
+			memset(buffer, 0, BLCKSZ);
+		}
+		else
+		{
+			unsigned	rb;
+
+			/* Read the block from the correct source, except if dry-run. */
+			rb = pg_pread(s->fd, buffer, BLCKSZ, offsetmap[i]);
+			if (rb != BLCKSZ)
+			{
+				if (rb < 0)
+					pg_fatal("could not read file \"%s\": %m", s->filename);
+				else
+					pg_fatal("could not read file \"%s\": read only %d of %d bytes at offset %u",
+							 s->filename, (int) rb, BLCKSZ,
+							 (unsigned) offsetmap[i]);
+			}
+		}
+
+		/* Write out the block. */
+		if ((wb = write(wfd, buffer, BLCKSZ)) != BLCKSZ)
+		{
+			if (wb < 0)
+				pg_fatal("could not write file \"%s\": %m", output_filename);
+			else
+				pg_fatal("could not write file \"%s\": wrote only %d of %d bytes",
+						 output_filename, (int) wb, BLCKSZ);
+		}
+
+		/* Update the checksum computation. */
+		if (pg_checksum_update(checksum_ctx, buffer, BLCKSZ) < 0)
+			pg_fatal("could not update checksum of file \"%s\"",
+					 output_filename);
+	}
+
+	/* Debugging output. */
+	if (zero_blocks > 0)
+	{
+		if (dry_run)
+			pg_log_debug("would have zero-filled %u blocks", zero_blocks);
+		else
+			pg_log_debug("zero-filled %u blocks", zero_blocks);
+	}
+
+	/* Close the output file. */
+	if (wfd >= 0 && close(wfd) != 0)
+		pg_fatal("could not close \"%s\": %m", output_filename);
+}
diff --git a/src/bin/pg_combinebackup/reconstruct.h b/src/bin/pg_combinebackup/reconstruct.h
new file mode 100644
index 0000000000..c599a70d42
--- /dev/null
+++ b/src/bin/pg_combinebackup/reconstruct.h
@@ -0,0 +1,32 @@
+/*-------------------------------------------------------------------------
+ *
+ * reconstruct.h
+ *		Reconstruct full file from incremental file and backup chain.
+ *
+ * Copyright (c) 2017-2023, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/bin/pg_combinebackup/reconstruct.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef RECONSTRUCT_H
+#define RECONSTRUCT_H
+
+#include "common/checksum_helper.h"
+#include "load_manifest.h"
+
+extern void reconstruct_from_incremental_file(char *input_filename,
+											  char *output_filename,
+											  char *relative_path,
+											  char *bare_file_name,
+											  int n_prior_backups,
+											  char **prior_backup_dirs,
+											  manifest_data **manifests,
+											  char *manifest_path,
+											  pg_checksum_type checksum_type,
+											  int *checksum_length,
+											  uint8 **checksum_payload,
+											  bool dry_run);
+
+#endif
diff --git a/src/bin/pg_combinebackup/t/001_basic.pl b/src/bin/pg_combinebackup/t/001_basic.pl
new file mode 100644
index 0000000000..fb66075d1a
--- /dev/null
+++ b/src/bin/pg_combinebackup/t/001_basic.pl
@@ -0,0 +1,23 @@
+# Copyright (c) 2021-2023, PostgreSQL Global Development Group
+
+use strict;
+use warnings;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+my $tempdir = PostgreSQL::Test::Utils::tempdir;
+
+program_help_ok('pg_combinebackup');
+program_version_ok('pg_combinebackup');
+program_options_handling_ok('pg_combinebackup');
+
+command_fails_like(
+	['pg_combinebackup'],
+	qr/no input directories specified/,
+	'input directories must be specified');
+command_fails_like(
+	[ 'pg_combinebackup', $tempdir ],
+	qr/no output directory specified/,
+	'output directory must be specified');
+
+done_testing();
diff --git a/src/bin/pg_combinebackup/t/002_compare_backups.pl b/src/bin/pg_combinebackup/t/002_compare_backups.pl
new file mode 100644
index 0000000000..d7f9e98b9c
--- /dev/null
+++ b/src/bin/pg_combinebackup/t/002_compare_backups.pl
@@ -0,0 +1,153 @@
+# Copyright (c) 2021-2023, PostgreSQL Global Development Group
+
+use strict;
+use warnings;
+use File::Compare;
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+# Set up a new database instance.
+my $primary = PostgreSQL::Test::Cluster->new('primary');
+$primary->init(has_archiving => 1, allows_streaming => 1);
+$primary->start;
+
+# Create some test tables, each containing one row of data, plus a whole
+# extra database.
+$primary->safe_psql('postgres', <<EOM);
+CREATE TABLE will_change (a int, b text);
+INSERT INTO will_change VALUES (1, 'initial test row');
+CREATE TABLE will_grow (a int, b text);
+INSERT INTO will_grow VALUES (1, 'initial test row');
+CREATE TABLE will_shrink (a int, b text);
+INSERT INTO will_shrink VALUES (1, 'initial test row');
+CREATE TABLE will_get_vacuumed (a int, b text);
+INSERT INTO will_get_vacuumed VALUES (1, 'initial test row');
+CREATE TABLE will_get_dropped (a int, b text);
+INSERT INTO will_get_dropped VALUES (1, 'initial test row');
+CREATE TABLE will_get_rewritten (a int, b text);
+INSERT INTO will_get_rewritten VALUES (1, 'initial test row');
+CREATE DATABASE db_will_get_dropped;
+EOM
+
+# Take a full backup.
+my $backup1path = $primary->backup_dir . '/backup1';
+$primary->command_ok(
+	[ 'pg_basebackup', '-D', $backup1path, '--no-sync', '-cfast' ],
+	"full backup");
+
+# Now make some database changes.
+$primary->safe_psql('postgres', <<EOM);
+UPDATE will_change SET b = 'modified value' WHERE a = 1;
+INSERT INTO will_grow
+	SELECT g, 'additional row' FROM generate_series(2, 5000) g;
+TRUNCATE will_shrink;
+VACUUM will_get_vacuumed;
+DROP TABLE will_get_dropped;
+CREATE TABLE newly_created (a int, b text);
+INSERT INTO newly_created VALUES (1, 'row for new table');
+VACUUM FULL will_get_rewritten;
+DROP DATABASE db_will_get_dropped;
+CREATE DATABASE db_newly_created;
+EOM
+
+# Take an incremental backup.
+my $backup2path = $primary->backup_dir . '/backup2';
+$primary->command_ok(
+	[ 'pg_basebackup', '-D', $backup2path, '--no-sync', '-cfast',
+	  '--incremental', $backup1path . '/backup_manifest' ],
+	"incremental backup");
+
+# Find an LSN to which either backup can be recovered.
+my $lsn = $primary->safe_psql('postgres', "SELECT pg_current_wal_lsn();");
+
+# Make sure that the WAL segment containing that LSN has been archived.
+# PostgreSQL won't issue two consecutive XLOG_SWITCH records, and the backup
+# just issued one, so call txid_current() to generate some WAL activity
+# before calling pg_switch_wal().
+$primary->safe_psql('postgres', 'SELECT txid_current();');
+$primary->safe_psql('postgres', 'SELECT pg_switch_wal()');
+
+# Now wait for the LSN we chose above to be archived.
+my $archive_wait_query =
+  "SELECT pg_walfile_name('$lsn') <= last_archived_wal FROM pg_stat_archiver;";
+$primary->poll_query_until('postgres', $archive_wait_query)
+  or die "Timed out while waiting for WAL segment to be archived";
+
+# Perform PITR from the full backup. Disable archive_mode so that the archive
+# doesn't find out about the new timeline; that way, the later PITR below will
+# choose the same timeline.
+my $pitr1 = PostgreSQL::Test::Cluster->new('pitr1');
+$pitr1->init_from_backup($primary, 'backup1',
+						 standby => 1, has_restoring => 1);
+$pitr1->append_conf('postgresql.conf', qq{
+recovery_target_lsn = '$lsn'
+recovery_target_action = 'promote'
+archive_mode = 'off'
+});
+$pitr1->start();
+
+# Perform PITR to the same LSN from the incremental backup. Use the same
+# basic configuration as before.
+my $pitr2 = PostgreSQL::Test::Cluster->new('pitr2');
+$pitr2->init_from_backup($primary, 'backup2',
+						 standby => 1, has_restoring => 1,
+						 combine_with_prior => [ 'backup1' ]);
+$pitr2->append_conf('postgresql.conf', qq{
+recovery_target_lsn = '$lsn'
+recovery_target_action = 'promote'
+archive_mode = 'off'
+});
+$pitr2->start();
+
+# Wait until both servers exit recovery.
+$pitr1->poll_query_until('postgres',
+						 "SELECT NOT pg_is_in_recovery();")
+  or die "Timed out while waiting apply to reach LSN $lsn";
+$pitr2->poll_query_until('postgres',
+						 "SELECT NOT pg_is_in_recovery();")
+  or die "Timed out while waiting apply to reach LSN $lsn";
+
+# Perform a logical dump of each server, and check that they match.
+# It would be much nicer if we could physically compare the data files, but
+# that doesn't really work. The contents of the page hole aren't guaranteed to
+# be identical, and there can be other discrepancies as well. To make this work
+# we'd need the equivalent of each AM's rm_mask functon written or at least
+# callable from Perl, and that doesn't seem practical.
+#
+# NB: We're just using the primary's backup directory for scratch space here.
+# This could equally well be any other directory we wanted to pick.
+my $backupdir = $primary->backup_dir;
+my $dump1 = $backupdir . '/pitr1.dump';
+my $dump2 = $backupdir . '/pitr2.dump';
+$pitr1->command_ok([
+	'pg_dumpall', '-f', $dump1, '--no-sync', '--no-unlogged-table-data',
+		'-d', $pitr1->connstr('postgres'),
+	],
+	'dump from PITR 1');
+$pitr1->command_ok([
+	'pg_dumpall', '-f', $dump2, '--no-sync', '--no-unlogged-table-data',
+		'-d', $pitr1->connstr('postgres'),
+	],
+	'dump from PITR 2');
+
+# Compare the two dumps, there should be no differences.
+my $compare_res = compare($dump1, $dump2);
+note($dump1);
+note($dump2);
+is($compare_res, 0, "dumps are identical");
+
+# Provide more context if the dumps do not match.
+if ($compare_res != 0)
+{
+	my ($stdout, $stderr) =
+		run_command([ 'diff', '-u', $dump1, $dump2 ]);
+	print "=== diff of $dump1 and $dump2\n";
+	print "=== stdout ===\n";
+	print $stdout;
+	print "=== stderr ===\n";
+	print $stderr;
+	print "=== EOF ===\n";
+}
+
+done_testing();
diff --git a/src/bin/pg_combinebackup/t/003_timeline.pl b/src/bin/pg_combinebackup/t/003_timeline.pl
new file mode 100644
index 0000000000..73626f060c
--- /dev/null
+++ b/src/bin/pg_combinebackup/t/003_timeline.pl
@@ -0,0 +1,89 @@
+# Copyright (c) 2021-2023, PostgreSQL Global Development Group
+#
+# This test aims to validate that restoring an incremental backup works
+# properly even when the reference backup is on a different timeline.
+
+use strict;
+use warnings;
+use File::Compare;
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+# Set up a new database instance.
+my $node1 = PostgreSQL::Test::Cluster->new('node1');
+$node1->init(has_archiving => 1, allows_streaming => 1);
+$node1->start;
+
+# Create a table and insert a test row into it.
+$node1->safe_psql('postgres', <<EOM);
+CREATE TABLE mytable (a int, b text);
+INSERT INTO mytable VALUES (1, 'aardvark');
+EOM
+
+# Take a full backup.
+my $backup1path = $node1->backup_dir . '/backup1';
+$node1->command_ok(
+	[ 'pg_basebackup', '-D', $backup1path, '--no-sync', '-cfast' ],
+	"full backup from node1");
+
+# Insert a second row on the original node.
+$node1->safe_psql('postgres', <<EOM);
+INSERT INTO mytable VALUES (2, 'beetle');
+EOM
+
+# Now take an incremental backup.
+my $backup2path = $node1->backup_dir . '/backup2';
+$node1->command_ok(
+	[ 'pg_basebackup', '-D', $backup2path, '--no-sync', '-cfast',
+	  '--incremental', $backup1path . '/backup_manifest' ],
+	"incremental backup from node1");
+
+# Restore the incremental backup and use it to create a new node.
+my $node2 = PostgreSQL::Test::Cluster->new('node2');
+$node2->init_from_backup($node1, 'backup2',
+						 combine_with_prior => [ 'backup1' ]);
+$node2->start();
+
+# Insert rows on both nodes.
+$node1->safe_psql('postgres', <<EOM);
+INSERT INTO mytable VALUES (3, 'crab');
+EOM
+$node2->safe_psql('postgres', <<EOM);
+INSERT INTO mytable VALUES (4, 'dingo');
+EOM
+
+# Take another incremental backup, from node2, based on backup2 from node1.
+my $backup3path = $node1->backup_dir . '/backup3';
+$node2->command_ok(
+	[ 'pg_basebackup', '-D', $backup3path, '--no-sync', '-cfast',
+	  '--incremental', $backup2path . '/backup_manifest' ],
+	"incremental backup from node2");
+
+# Restore the incremental backup and use it to create a new node.
+my $node3 = PostgreSQL::Test::Cluster->new('node3');
+$node3->init_from_backup($node1, 'backup3',
+						 combine_with_prior => [ 'backup1', 'backup2' ]);
+$node3->start();
+
+# Let's insert one more row.
+$node3->safe_psql('postgres', <<EOM);
+INSERT INTO mytable VALUES (5, 'elephant');
+EOM
+
+# Now check that we have the expected rows.
+my $result = $node3->safe_psql('postgres', <<EOM);
+select string_agg(a::text, ':'), string_agg(b, ':') from mytable;
+EOM
+is($result, '1:2:4:5|aardvark:beetle:dingo:elephant');
+
+# Let's also verify all the backups.
+for my $backup_name (qw(backup1 backup2 backup3))
+{
+	$node1->command_ok(
+		[ 'pg_verifybackup', $node1->backup_dir . '/' . $backup_name ],
+		"verify backup $backup_name");
+}
+
+# OK, that's all.
+done_testing();
